# -*- coding: utf-8 -*-

import os
from MoinMoin.action import AttachFile
from MoinMoin import wikiutil, config
from MoinMoin.Page import Page

def get_picture (request, image):
    if image.startswith("ftp://") or\
               image.startswith("http://") or\
        image.startswith("https://"):
            return (image, image)

    else:
        if image.startswith("./"):
            filename = image[2:]
            folder = request.page.page_name
        else:
            filename = os.path.basename(image)
            folder = os.path.dirname(image)
        url = AttachFile.getAttachUrl(folder, filename, request)
        # Commented due a dump wiki error, use a siple relplace instead
        #full_url = AttachFile.getAttachUrl(folder, filename, request, do='view')
        full_url = url.replace('do=get', 'do=view')

        return (full_url, url)

def execute(macro, args):
    try:
        width = None
        height = None
        align = None
        args = unicode(args).split(u",")
        image = args[0].strip()
        tag_class = "inline"
        if len(args) > 1:
            if not args[1].strip():
                width = None
                height = None
            else:
                p = args[1].split("x")
                width = int(p[0].strip())
                if len(p) > 1:
                    height = int(p[1].strip())
                else:
                    height = None
        if len(args) > 2:
            align = args[2].strip()
            if align == "left":
                tag_class = "inline_left"
            if align == "center":
                tag_class = "inline_center"
            if align == "right":
                tag_class = "inline_right"
    except:
        return u"<strong>Errore col parametro</strong> - Usa:" \
               u"<code>[[Immagine(percorso[, larghezza[altezza], allineamento]]])]]</code><br /><br />"\
           u"Esempio:"\
           u"<code>[[Immagine(./esempio.png, 20x10, center )]]</code>"
    
    full_url, url = get_picture(macro.request, image)

    if width is not None:
        width = 'width="%s"' % width
    else:
        width = ''

    if height is not None:
        height = 'height="%s"' % height
    else: 
            height = ''

    if align is not None and tag_class != 'inline':
        align = 'align="%s"' % align
    else:
        align = ''


    html = '<img class="%s" src="%s" %s %s %s />' % (tag_class, url, width, height, align)

    # This creates a url to view image
    html = '<a href="%s">%s</a>' % (full_url,html)

    if url == "":
        return u"<strong>Errore</strong>: '%s' non e' un'immagine" % image
    
    return html 
