# -*- coding: iso-8859-1 -*-
"""
    MoinMoin - SupportedReleases Macro 
    
    @copyright: 2008 Ubuntu-it - Modified by Milo Casagrande <milo@ubuntu.com>, Leo Iannacone <l3on@ubuntu.com>, Alessio Treglia <quadrispro@ubuntu.com>.
"""

from MoinMoin import config, wikiutil

def execute(self, args):

	if args == '':
      		raise Exception('ExceptionArguments - VersioniSupportate: inserire il nome di almeno un rilascio di Ubuntu nella macro VersioniSupportate.')

	pageRelease = { 'dapper': "DapperNoteDiRilascio", 'feisty': "FeistyNoteDiRilascio", 'gutsy': "GutsyNoteDiRilascio", 'hardy': 'HardyNoteDiRilascio', 'intrepid': 'IntrepidNoteDiRilascio', 'jaunty': 'JauntyNoteDiRilascio', 'karmic': 'KarmicNoteDiRilascio'}

	numRelease = { 'dapper': " 6.06", 'feisty': " 7.04", 'gutsy': ' 7.10', 'hardy': ' 8.04', 'intrepid':'8.10', 'jaunty': '9.04' , 'karmic': '9.10'}

	nameRelease = { 'puppa': 'easteregg', 'warty': 'deprecated', 'hoary': 'deprecated', 'breezy': 'deprecated', 'edgy': 'deprecated', 'dapper': "deprecated", 'feisty': 'deprecated', 'gutsy': 'deprecated', 'hardy': 'Hardy Heron', 'intrepid': 'deprecated', 'jaunty': 'Jaunty Jackalope', 'karmic': 'Karmic Koala', 'lucid': 'unstable' }


	self.result = []
	# Creating header
	self.result.append(self.formatter.div(1, css_class="supported-releases"))
	self.result.append(self.formatter.div(1, css_class="toc-top-sx"))
	self.result.append(self.formatter.div(0))
	self.result.append(self.formatter.div(1, css_class="toc-top-dx"))
	self.result.append(self.formatter.div(0))

	# This div is for IE
	self.result.append(self.formatter.div(1)) 

	self.result.append(self.formatter.div(1, css_class="supported-releases-core"))

	# Preparing to cycle
	self.result.append('<p class="supported-releases-heading">Versioni supportate:</p>')

	# Just a bool to check if there are some releases in macro. 
	has_releases = False

	# Cycling args
	for arg in args.split():
		# If it's a typing mistake
		if arg not in nameRelease:  
			raise Exception('ExceptionRelease - VersioniSupportate: Attenzione la release "%s" non esiste.'%  arg )
		# If it's deprecated
		if nameRelease[arg] == 'deprecated':
			continue	
		# If it's unstable
		if nameRelease[arg] == 'unstable':
			raise Exception('ExceptionRelease - VersioniSupportate: E\' vietato inserire la release "%s" poiche\' e\' ancora in fase di sviluppo.' % arg )
		# Smile, it's a simple easteregg
		if nameRelease[arg] == 'easteregg':
			raise Exception('ExceptionRelease: le prestazioni sessuali di MiloCasagrande nei confronti di RemoQuintino non sono state convincenti per avere il rilascio di "%s".'%  arg )
		else:	
			self.result.append('Ubuntu %s <a href="/%s">%s</a><br />' % (numRelease[arg], pageRelease[arg], nameRelease[arg]))
			has_releases = True


	# If there are no releaes, do nothing.
	if has_releases is False:
		return ''

	# Closing div supported-release-core
        self.result.append(self.formatter.div(0))
        self.result.append(self.formatter.div(0))
	
	# Creating footer  
	self.result.append(self.formatter.div(1, css_class="toc-bottom-sx"))
	self.result.append(self.formatter.div(0))
	self.result.append(self.formatter.div(1, css_class="toc-bottom-dx"))
	self.result.append(self.formatter.div(0))
	
	self.result.append(self.formatter.div(0))

	return ''.join(self.result) 
