"""
    MoinMoin ubuntu-it theme

    @copyright: (c) 2003-2004 by Nir Soffer, Thomas Waldmann
		    2008  Ubuntu-it - Modified by Milo Casagrande <milo@ubuntu.com>, Leo Iannacone <l3on@ubuntu.com>, Alessio Treglia <quadrispro@ubuntu.com>.
    @license: GNU GPL, see COPYING for details.

     Is essentially a massive rip-off of the Ubuntu theme, hacked up to make it fit nicer with the ubuntu-it top bar. (Matthew East)
    
    This is the base of *ubuntu-it.py themes (Leo Iannacone).
"""

from MoinMoin.theme import ThemeBase
from MoinMoin import wikiutil
from MoinMoin.Page import Page

class Theme(ThemeBase):
	
    name = 'ubuntu-it'

	# Overriding theme/__init__.py #########################################

    # fake _ function to get gettext recognize those texts:
    _ = lambda x: x

    # TODO: remove icons that are not used any more.
    icons = {
        # key         alt                        icon filename      w   h
        # FileAttach
        'attach':     ("%(attach_count)s",       "moin-attach.png",   16, 16),
        'info':       ("[INFO]",                 "moin-info.png",     16, 16),
        'attachimg':  (_("[ATTACH]"),            "attach.png",        32, 32),
        # RecentChanges
        'rss':        (_("[RSS]"),               "moin-rss.png",      16, 16),
        'deleted':    (_("[DELETED]"),           "moin-deleted.png",  16, 16),
        'updated':    (_("[UPDATED]"),           "moin-updated.png",  16, 16),
        'renamed':    (_("[RENAMED]"),           "moin-renamed.png",  16, 16),
        'conflict':   (_("[CONFLICT]"),          "moin-conflict.png", 16, 16),
        'new':        (_("[NEW]"),               "moin-new.png",      16, 16),
        'diffrc':     (_("[DIFF]"),              "moin-diff.png",     16, 16),
        'diff':     (_("[DIFF]"),              "moin-diff.png",     16, 16),
        # General
        'bottom':     (_("[BOTTOM]"),            "moin-bottom.png",   16, 16),
        'top':        (_("[TOP]"),               "moin-top.png",      16, 16),
        'www':        ("[WWW]",                  "moin-www.png",      16, 16),
        'mailto':     ("[MAILTO]",               "moin-email.png",    16, 16),
        'news':       ("[NEWS]",                 "moin-news.png",     16, 16),
        'telnet':     ("[TELNET]",               "moin-telnet.png",   16, 16),
        'ftp':        ("[FTP]",                  "moin-ftp.png",      16, 16),
        'file':       ("[FILE]",                 "moin-ftp.png",      16, 16),
        # search forms
        'searchbutton': ("[?]",                  "moin-search.png",   16, 16),
        'interwiki':  ("[%(wikitag)s]",          "moin-inter.png",    16, 16),

        # smileys (this is CONTENT, but good looking smileys depend on looking
        # adapted to the theme background color and theme style in general)
        #vvv    ==      vvv  this must be the same for GUI editor converter
        'X-(':        ("X-(",                    'angry.png',         16, 16),
        ':D':         (":D",                     'biggrin.png',       16, 16),
        '<:(':        ("<:(",                    'frown.png',         16, 16),
        ':o':         (":o",                     'redface.png',       16, 16),
        ':(':         (":(",                     'sad.png',           16, 16),
        ':)':         (":)",                     'smile.png',         16, 16),
        'B)':         ("B)",                     'smile2.png',        16, 16),
        ':))':        (":))",                    'smile3.png',        16, 16),
        ';)':         (";)",                     'smile4.png',        16, 16),
        '/!\\':       ("/!\\",                   'alert.png',         16, 16),
        '<!>':        ("<!>",                    'attention.png',     16, 16),
        '(!)':        ("(!)",                    'idea.png',          16, 16),
        ':-?':        (":-?",                    'tongue.png',        16, 16),
        ':\\':        (":\\",                    'ohwell.png',        16, 16),
        '>:>':        (">:>",                    'devil.png',         16, 16),
        '|)':         ("|)",                     'tired.png',         16, 16),
        ':-(':        (":-(",                    'sad.png',           16, 16),
        ':-)':        (":-)",                    'smile.png',         16, 16),
        'B-)':        ("B-)",                    'smile2.png',        16, 16),
        ':-))':       (":-))",                   'smile3.png',        16, 16),
        ';-)':        (";-)",                    'smile4.png',        16, 16),
        '|-)':        ("|-)",                    'tired.png',         16, 16),
        '(./)':       ("(./)",                   'checkmark.png',     16, 16),
        '{OK}':       ("{OK}",                   'thumbs-up.png',     16, 16),
        '{X}':        ("{X}",                    'icon-error.png',    16, 16),
        '{i}':        ("{i}",                    'icon-info.png',     16, 16),
        '{1}':        ("{1}",                    'prio1.png',         15, 13),
        '{2}':        ("{2}",                    'prio2.png',         15, 13),
        '{3}':        ("{3}",                    'prio3.png',         15, 13),
        '{*}':        ("{*}",                    'star_on.png',       16, 16),
        '{o}':        ("{o}",                    'star_off.png',      16, 16),
    }
    del _
    linkSchemas = ['http://', 'https://', 'ftp://', 'irc://', 'mailto:']

# Public functions #####################################################

    def header(self, d, **kw):
        """ Assemble wiki header
        
        @param d: parameter dictionary
        @rtype: unicode
        @return: page header html
        """
        html = [
            
            # Pre header custom html
            self.emit_custom_html(self.cfg.page_header1),
            # Google Analytics
	    u'''<script type="text/javascript">
			var gaJsHost = (("https:" == document.location.protocol) ? "https://ssl." : "http://www.");
			document.write(unescape("%3Cscript src='" + gaJsHost + "google-analytics.com/ga.js' type='text/javascript'%3E%3C/script%3E"));
		</script>
		<script type="text/javascript">
			try {
				var pageTracker = _gat._getTracker("UA-8147493-1");
				pageTracker._trackPageview();
			} catch(err) {}
		</script>''',
	    # IE sucks if its version is less or equal to 6.0 
	    u'<!--[if lte IE 6]>   <div align="center" style="clear:both;"><font color="#fff"><b> La visualizzazione di questo sito &egrave; ottimizzata per IE7 e Firefox</b></font></div>  <![endif]-->',
	    # Container div
            u'<div class="container">',
            u'<div class="bg-left">', 
            u'</div>',
	    u'<div class="contenuto">',

            # self.datescript(),
            u'<div class="bg-right">', 
	    u'</div>',
            u'<div class="topNav"></div>'
            # Header
            u'<div id="header">',
	    self.headerTabs(),
            self.otherThemes(),
            u'<div id="search">',
            self.searchform(d),
            u'</div>',
#            self.trail(d),
	    u'<div id="edit-extra">',
            self.editbar(d),
            self.extranav(d),
            u'</div></div>',
            self.msg(d),
            # Post header custom html (not recommended)
            self.emit_custom_html(self.cfg.page_header2),
            # Start of page
	    u'<div>',
            self.startPage(),
            self.title(d),


        ]
        return u'\n'.join(html)

    editorheader = header

    # Added by Milo for testing purposes

    def pageLastName(self, name):
        """ This should be in the Page class, but its not """
        return name[name.rfind('/') + 1:]

    def shortenPagename(self, name):
        """ Shorten page names
        
        This is a modified copy from theme/__init__.py. Modified to
        show only the last name of a page, even if there is room for
        the full name.
        """
        name = self.pageLastName(name)
        maxLength = self.maxPagenameLength()
        if len(name) > maxLength:
            half, left = divmod(maxLength - 3, 2)
            name = u'%s...%s' % (name[:half + left], name[-half:])
        return name

    # End of added section

    def footer(self, d, **keywords):
        """ Assemble wiki footer
        
        @param d: parameter dictionary
        @keyword ...:...
        @rtype: unicode
        @return: page footer html
        """
        page = d['page']
        html = [
	    
            u'</div></div>',
            # End of page
            #self.pageinfo(page),

            u'<div class="footer">',
            # Footer
            self.footerlinks(), 
            self.showversion(d, **keywords),

            self.endPage(),
            
            # Pre footer custom html (not recommended!)
            self.emit_custom_html(self.cfg.page_footer1),


            # Post footer custom html
            self.emit_custom_html(self.cfg.page_footer2),
             u'</div>',        

           
            u'<div class=bottom-left>',
            u'</div>',

            u'<div class="bottom-right">', 
            u'</div></div>&nbsp;</body></html>',

            ]
        return u'\n'.join(html)

    def extranav(self, d):
        """ Assemble the helpful extra navigation

	Of course in a normal theme these come from wikiconfig.py 
        
        @param d: parameter dictionary
        @rtype: unicode
        @return: extranav html
        """
        request = self.request
        _ = request.getText
        preferencesPage = wikiutil.getSysPage(request, 'UserPreferences')
        changesPage = wikiutil.getSysPage(request, 'RecentChanges')
	indexPage = wikiutil.getSysPage(request, 'Documentazione/Indice')

        extralinks = []

        # If user is logged in, give them the Preferences link, if not, don't.
        if request.user.valid and request.user.name:
            # Set the Logut action
	    extralinks.append(d['page'].link_to(request, text=_('Esci', formatted=False),
		    querystr={'action': 'logout', 'logout': 'logout'}, id="logout"))
	    # Set pref page to localized Preferences page
            title = preferencesPage.split_title(request)
            extralinks.append(preferencesPage.link_to(request, text=title))
            # Set page to localized RC page
            title = changesPage.split_title(request)
            extralinks.append(changesPage.link_to(request, text=title))
            # Set user's personal page
            interwiki = wikiutil.getInterwikiHomePage(request)
            name = request.user.name
            aliasName = request.user.aliasname
            if not aliasName:
                aliasName = name
            title = "%s @ %s" % (aliasName, interwiki[0])
            homelink = (request.formatter.interwikilink(1, title=title, id="userhome", *interwiki) +
                        request.formatter.text(name) +
                        request.formatter.interwikilink(0, title=title, id="userhome", *interwiki)
                        )
            extralinks.append(homelink)
        else:
            pass

	# Set the index link
	extralinks.append(indexPage.link_to(request, text='Indice'))

        extralinks = [u'<li>%s</li>\n' % link for link in extralinks]
        html = u'<ul class="extranav">\n%s</ul>' % ''.join(extralinks)
        return html


    def editbar(self, d):
        """ Assemble the page edit bar.

        Display on existing page. Replace iconbar, showtext, edit text,
        refresh cache and available actions.
        
        @param d: parameter dictionary
        @rtype: unicode
        @return: iconbar html
        """
        page = d['page']       
        if not self.shouldShowEditbar(page):
            return ''

        # Use cached editbar if possible.
        cacheKey = 'editbar'
        cached = self._cache.get(cacheKey)
        if cached:
            return cached

        # Make new edit bar
        request = self.request
        _ = self.request.getText
        link = wikiutil.link_tag
        quotedname = wikiutil.quoteWikinameURL(page.page_name)
        links = []
        add = links.append

        cercaPagina = wikiutil.getSysPage(request, 'CercaPagina')
        title = cercaPagina.split_title(request)

        add(cercaPagina.link_to(request, text=title))
        
        # Parent page
        parent = page.getParentPage()
        if parent:
           add(parent.link_to(request, _("Pagina superiore", formatted=False))) 
       
        # Page actions
        if page.isWritable() and request.user.valid and request.user.may.write(page.page_name):
            #add(link(request, quotedname + '?action=edit', _('Edit')))
            #add(link(request, quotedname + '?action=info',
            #     _('Cronologia', formatted=False)))
            add(self.editorLink(page))
            add(d['page'].link_to(request, text=_('Allegati', formatted=False), querystr={'action':'AttachFile'}))
            add(self.infoLink(page))
      	    add(self.subscribeLink(page))
            add(self.actionsMenu(page))
        elif not request.user.valid:
	           add(d['page'].link_to(request, text=_("Login per modificare", 
               formatted=False), querystr={'action': 'login'}, id="login"))

	          # Moin < 1.5.8
            #preferencesPage = wikiutil.getSysPage(request, 'UserPreferences')
            #add(preferencesPage.link_to(request, text=_("Login per modificare")))
        else:
            add(_('Pagina non modificabile', formatted=False))             

        # Format
        items = '\n'.join(['<li>%s</li>' % item for item in links if item != ''])
        html = u'<ul class="editbar">\n%s\n</ul>\n' % items
        
        # cache for next call
        self._cache[cacheKey] = html
        return html

    def sisternav(self):
        """ Assemble fancy nav tabs to the sister sites

        This requires support in the CSS for the tabs look.  In order for
        the (always current here) "wiki" tab to look attached to the paper,
        in fact the masthead is of fixed height, and the bg tile contains 
	the image of the "bar" underline.  The not-current tabs get a line
	under them via their background tile too.
	
	#########################        
	Overwritten by headerTabs 
	#########################


        @rtype: unicode
        @return: nav tabs html
        """

        html = u'''<script type="text/javascript">pulsanti("help")</script>'''
        return html
        return u''

# It's for not have more than one the same directory images for all theme.
    def img_url(self, img):
        """ Generate an image href

        @param img: the image filename
        @rtype: string
        @return: the image href
        """
#        return "%s/%s/img/%s" % (self.cfg.url_prefix, self.name, img)
        return "%s/%s/img/%s" % (self.cfg.url_prefix, "ubuntu-it", img)




    def footerlinks(self):
        """ Copyright notices and local links

        Nice and boring compared to the other stuff. 
        
        @rtype: unicode
        @return: extra footer html
        """

        html = u'''<div id="ubuntulinks">&copy; 2005 - 2010 <a href="http://www.canonical.com">Canonical Ltd.</a> Ubuntu e Canonical sono marchi registrati da Canonical Ltd.<br />
        <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/deed.it"><img alt="Licenza Creative Commons" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/2.5/it/80x15.png" /></a>&nbsp;Questa <span xmlns:dc="http://purl.org/dc/elements/1.1/" href="http://purl.org/dc/dcmitype/Text" rel="dc:type">opera</span> &egrave; pubblicata sotto una <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/legalcode">licenza Creative Commons</a><br><br>
        </div>'''
        
        return html
        return u''

    def headerTabs(self):
	""" Header tabs for navigation

	Show tabs to navigate  in Forum - Web - Planet and much more.
	"""
	community = {"Web":"www.ubuntu-it.org", "Documentazione":"wiki.ubuntu-it.org", "Forum":"forum.ubuntu-it.org","Contribuire":"www.ubuntu-it.org/index.php?page=contribuire","Planet":"planet.ubuntu-it.org" }

	html = '<div id="pulsante"><ul>'
	# Vector community prints community keywords ordering them in right way
	vector_community = [ "Web", "Documentazione", "Forum", "Planet"]
	
	for site in vector_community:
		if site == "Documentazione":
			id_pulsante = "current"
		else:
			id_pulsante = "plain"

		html += '<li id=' + id_pulsante + '><a href="http://' + community[site] + '">' + site + '</a></li>'

	html +='</ul></div>'
	
	return html
        return u''

    def otherThemes(self):
        """ Header themes links
        
	Show the current page with other themes
	"""
        pageURL = self.request.page.url(self.request, escape=0)
        url = '%s?action=theme&theme=' % (pageURL)

	url_img = '/htdocs/common/img/' 
        
        # Dictionaries holding the theme names as keys and distro name as value ...
        themes = {'ubuntu-it': 'Ubuntu', 'kubuntu-it': 'Kubuntu', 'xubuntu-it': 'Xubuntu', 'edubuntu-it': 'Edubuntu'}
        # ... and icon name as value
        icons = {'ubuntu-it': 'ubuntu-it-icon.png', 'kubuntu-it': 'kubuntu-it-icon.png', 'xubuntu-it': 'xubuntu-it-icon.png', 'edubuntu-it': 'edubuntu-it-icon.png'}

        currentTheme = self.request.theme.name
	# If not javascript is enabled:
	noscript = '<noscript><span class="noscript" >Abilitare i JavaScript per sfruttare tutte le funzionalit&agrave; del sito!</span></noscript>'

        html = '<div class="otherthemeslinks">%s<small>' % noscript
        
        for theme in themes:
            if currentTheme == theme:
                continue
            else:
#                html +=u'<a href="' + url + theme + '"><img src="' + url_img + icons[theme] + '" border=0 align="absmiddle"/>&nbsp;' + themes[theme] + '&nbsp;&nbsp;</a>'
                html +=u'<a href="' + url + theme + '"><img title="Cambia tema in '+ themes[theme] +'" src="' + url_img + icons[theme] + '" border=0 align="absmiddle"/>&nbsp;' + '&nbsp;&nbsp;</a>'
        html += '</small></div>'
	
        return html
        return u''


#def execute(request):
#    """
#    Generate and return a theme object
#        
#    @param request: the request object
#    @rtype: MoinTheme
#    @return: Theme object
#    """
#    return Theme(request)
