#!/bin/bash

function template()
{
	NAME=$1
	COLOUR=$2

	echo "
/*
Copyright © 2008 Ubuntu-it - Created by Milo Casagrande <milo@ubuntu.com>,
Leo Iannacone <l3on@ubuntu.com>, Alessio Treglia <quadrispro@ubuntu.com>. 
*/

/* Classes for styling Toc */

.toc-$NAME {
	margin: 0 0 1em 1em;
	float:right;
	width: 35%;
	font-size: 0.9em;
}

.toc-top-sx-$NAME {
	background-image: url('../img/$NAME/toc-top-sx.png');
	background-position: top left;
	height:10px;
	width:10px;
}

.toc-top-dx-$NAME {
	background-image: url('../img/$NAME/toc-top-dx.png');
	background-position: top right;
	height:10px;
	margin-left: 10px;
	margin-top: -10px;
	background-repeat: no-repeat;
	background-color: $COLOUR;
}

.toc-bottom-sx-$NAME {
	background-image: url('../img/$NAME/toc-bottom-sx.png');
	background-position: bottom left;
	height:11px;
	width:10px;
	margin-top: -11px;
	background-color: $COLOUR;
	background-repeat: no-repeat;
}

.toc-bottom-dx-$NAME	{
	background-image: url('../img/$NAME/toc-bottom-dx.png');
	background-position: bottom right;
	height:11px;
	background-repeat: no-repeat;
	margin-left: 10px;
	margin-top: -11px;
	background-color: $COLOUR;
}

.toc-core-$NAME {
	background-image: url('../img/$NAME/toc-logo.png');
	background-position: 90% 20px;
	background-color: $COLOUR;
	background-repeat: no-repeat;
	padding-left: 15px;
	min-height:110px;
	padding-right:25px;
}


p.toc-core-heading-$NAME {
	font-weight: bold;
	margin-top: 0px;
	}

.toc-core-$NAME a {
	text-decoration: none;
	color:#ffffff;

}
.toc-core-$NAME a:hover {
	text-decoration: underline;
	color:#ffffff;
}
"
}


BASE="../htdocs/common/css/"

echo "AmbienteGrafico #ffbd50
AmministrazioneSistema #ffa550
Architettura64Bit #569d56
Emulatori #ff7c50
Giochi #ff5950
Grafica #f6dc5b
Hardware  #c9c6bb
Installazione #9ac357
InternetRete #6baee4
Multimedia #646161
Programmazione #d08093
Radioamatori #dc9f56
Server #27d261
Sicurezza #27bbd2
Ufficio #7781c9 " | while read NAME COLOUR ; do template $NAME $COLOUR > $BASE$NAME.css ; done
	




